'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = composeMiddleware;

var _lodash = require('lodash');

var _createMiddleware = require('./createMiddleware');

var _createMiddleware2 = _interopRequireDefault(_createMiddleware);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function composeMiddleware() {
  for (var _len = arguments.length, middlewares = Array(_len), _key = 0; _key < _len; _key++) {
    middlewares[_key] = arguments[_key];
  }

  middlewares = (0, _lodash.compact)(middlewares);

  if (middlewares.length === 0) return function (store) {
    return function (dispatch) {
      return dispatch;
    };
  };
  if (middlewares.length === 1) return middlewares[0];

  if ((0, _lodash.every)(middlewares, function (middleware) {
    return middleware.actionHandlers;
  })) {
    var _ret = function () {
      // regroup all the action handlers in the middlewares by action type.
      var actionHandlers = {};
      middlewares.forEach(function (middleware) {
        (0, _lodash.forEach)(middleware.actionHandlers, function (actionHandler, type) {
          (actionHandlers[type] || (actionHandlers[type] = [])).push(actionHandler);
        });
      });
      return {
        v: (0, _createMiddleware2.default)((0, _lodash.mapValues)(actionHandlers, function (typeHandlers) {
          return composeMiddleware.apply(undefined, _toConsumableArray(typeHandlers));
        }))
      };
    }();

    if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
  }
  return function (store) {
    var handlers = middlewares.map(function (middleware) {
      return middleware(store);
    });
    return function (dispatch) {
      return handlers.reduceRight(function (next, handler) {
        return handler(next);
      }, dispatch);
    };
  };
}