'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createMiddleware;

var _lodash = require('lodash');

function createMiddleware(actionHandlers) {
  var result = function result(store) {
    var handlersForStore = (0, _lodash.mapValues)(actionHandlers, function (handler) {
      return handler(store);
    });
    return function (next) {
      var handlersForNext = (0, _lodash.mapValues)(handlersForStore, function (handler) {
        return handler(next);
      });
      return function (action) {
        var handler = handlersForNext[action.type];
        return handler ? handler(action) : next(action);
      };
    };
  };
  result.actionHandlers = actionHandlers;
  return result;
}